/*
 *	SHOWENV
 *	show Envrionment & Commandline
 *	Public Domain
 *	1996 by Volker Hemsen
 *	Compiler: GNU-C
 */

#include <stdio.h>
#include <stdlib.h>

int outlines=0;
int lines=20;

void key(int end);
void key(int end)
{
	fprintf(stdout,"--- press RETURN to %s ---",end ? "end":"next");
	fgetc(stdin);
}

void outline(char *s);
void outline(char *s)
{
	fprintf(stdout,"%s\n",s);
	if (outlines>=lines-2) {
		key(0);
		outlines=0;
	}
	outlines++;
}

int main(int argc,char *argv[],char *envp[]);
int main(int argc,char *argv[],char *envp[])
{
	{
		char *s=getenv("LINES");
		if (s!=NULL)
			sscanf(s,"%d",&lines);
	}
	{
		outline("Environment:");
		while ((*envp) && (**envp)) {
			fprintf(stdout,"  ");
			outline(*envp);
			envp++;
		}
		outline("Commandline:");
		{
			register int ii;
			char s[256];
			for(ii=0;ii<argc;ii++) {
				sprintf(s,"  %d %s",ii,argv[ii]);
				outline(s);
			}
		}
	}
	key(1);
	return 0;
}
