/* gl.h adapt pour mesa en LDG sur atari

   Version 1.0, 25 avril 1999, Emmanuel CURIS

   Ralis  partir de gl_ldg.h avec Eddie 2 / Calamus (ben si...)



   Modifications :

   -> tous les types sont en long, unsigned long ou float

   -> protection contre les inclusions multiples

   -> inclusion des prototypes

   -> transform GLenum en long donc l'numration en #define

*/



/* replace gl.h of mesa for Mesa_gl.ldg 

Revision 1.0  1999/02/24  Olivier Landemarre

Initial revision

*/



#ifndef GL_H_



#define GL_H_ /* Protection contre l'inclusion multiple */



	/* Boolean values */

#define GL_FALSE			  0L

#define GL_TRUE				  1L



	/* Data types */

#define GL_BYTE				  0x1400L

#define GL_UNSIGNED_BYTE		  0x1401L

#define GL_SHORT			  0x1402L

#define GL_UNSIGNED_SHORT		  0x1403L

#define GL_INT				  0x1404L

#define GL_UNSIGNED_INT			  0x1405L

#define GL_FLOAT			  0x1406L

#define GL_DOUBLE			  0x140AL

#define GL_2_BYTES			  0x1407L

#define GL_3_BYTES			  0x1408L

#define GL_4_BYTES			  0x1409L



	/* Primitives */

#define GL_LINES			  0x0001L

#define GL_POINTS			  0x0000L

#define GL_LINE_STRIP			  0x0003L

#define GL_LINE_LOOP			  0x0002L

#define GL_TRIANGLES			  0x0004L

#define GL_TRIANGLE_STRIP		  0x0005L

#define GL_TRIANGLE_FAN			  0x0006L

#define GL_QUADS			  0x0007L

#define GL_QUAD_STRIP			  0x0008L

#define GL_POLYGON			  0x0009L

#define GL_EDGE_FLAG			  0x0B43L



	/* Vertex Arrays */

#define GL_VERTEX_ARRAY			  0x8074L

#define GL_NORMAL_ARRAY			  0x8075L

#define GL_COLOR_ARRAY			  0x8076L

#define GL_INDEX_ARRAY			  0x8077L

#define GL_TEXTURE_COORD_ARRAY		  0x8078L

#define GL_EDGE_FLAG_ARRAY		  0x8079L

#define GL_VERTEX_ARRAY_SIZE		  0x807AL

#define GL_VERTEX_ARRAY_TYPE		  0x807BL

#define GL_VERTEX_ARRAY_STRIDE		  0x807CL

#define GL_NORMAL_ARRAY_TYPE		  0x807EL

#define GL_NORMAL_ARRAY_STRIDE		  0x807FL

#define GL_COLOR_ARRAY_SIZE		  0x8081L

#define GL_COLOR_ARRAY_TYPE		  0x8082L

#define GL_COLOR_ARRAY_STRIDE		  0x8083L

#define GL_INDEX_ARRAY_TYPE		  0x8085L

#define GL_INDEX_ARRAY_STRIDE		  0x8086L

#define GL_TEXTURE_COORD_ARRAY_SIZE	  0x8088L

#define GL_TEXTURE_COORD_ARRAY_TYPE	  0x8089L

#define GL_TEXTURE_COORD_ARRAY_STRIDE	  0x808AL

#define GL_EDGE_FLAG_ARRAY_STRIDE	  0x808CL

#define GL_VERTEX_ARRAY_POINTER		  0x808EL

#define GL_NORMAL_ARRAY_POINTER		  0x808FL

#define GL_COLOR_ARRAY_POINTER		  0x8090L

#define GL_INDEX_ARRAY_POINTER		  0x8091L

#define GL_TEXTURE_COORD_ARRAY_POINTER	  0x8092L

#define GL_EDGE_FLAG_ARRAY_POINTER	  0x8093L

#define GL_V2F				  0x2A20L

#define GL_V3F				  0x2A21L

#define GL_C4UB_V2F			  0x2A22L

#define GL_C4UB_V3F			  0x2A23L

#define GL_C3F_V3F			  0x2A24L

#define GL_N3F_V3F			  0x2A25L

#define GL_C4F_N3F_V3F			  0x2A26L

#define GL_T2F_V3F			  0x2A27L

#define GL_T4F_V4F			  0x2A28L

#define GL_T2F_C4UB_V3F			  0x2A29L

#define GL_T2F_C3F_V3F			  0x2A2AL

#define GL_T2F_N3F_V3F			  0x2A2BL

#define GL_T2F_C4F_N3F_V3F		  0x2A2CL

#define GL_T4F_C4F_N3F_V4F		  0x2A2DL



	/* Matrix Mode */

#define GL_MATRIX_MODE			  0x0BA0L

#define GL_MODELVIEW			  0x1700L

#define GL_PROJECTION			  0x1701L

#define GL_TEXTURE			  0x1702L



	/* Points */

#define GL_POINT_SMOOTH			  0x0B10L

#define GL_POINT_SIZE			  0x0B11L

#define GL_POINT_SIZE_GRANULARITY	  0x0B13L

#define GL_POINT_SIZE_RANGE		  0x0B12L



	/* Lines */

#define GL_LINE_SMOOTH			  0x0B20L

#define GL_LINE_STIPPLE			  0x0B24L

#define GL_LINE_STIPPLE_PATTERN		  0x0B25L

#define GL_LINE_STIPPLE_REPEAT		  0x0B26L

#define GL_LINE_WIDTH			  0x0B21L

#define GL_LINE_WIDTH_GRANULARITY	  0x0B23L

#define GL_LINE_WIDTH_RANGE		  0x0B22L



	/* Polygons */

#define GL_POINT			  0x1B00L

#define GL_LINE				  0x1B01L

#define GL_FILL				  0x1B02L

#define GL_CCW				  0x0901L

#define GL_CW				  0x0900L

#define GL_FRONT			  0x0404L

#define GL_BACK				  0x0405L

#define GL_CULL_FACE			  0x0B44L

#define GL_CULL_FACE_MODE		  0x0B45L

#define GL_POLYGON_SMOOTH		  0x0B41L

#define GL_POLYGON_STIPPLE		  0x0B42L

#define GL_FRONT_FACE			  0x0B46L

#define GL_POLYGON_MODE			  0x0B40L

#define GL_POLYGON_OFFSET_FACTOR	  0x8038L

#define GL_POLYGON_OFFSET_UNITS		  0x2A00L

#define GL_POLYGON_OFFSET_POINT		  0x2A01L

#define GL_POLYGON_OFFSET_LINE		  0x2A02L

#define GL_POLYGON_OFFSET_FILL		  0x8037L



	/* Display Lists */

#define GL_COMPILE			  0x1300L

#define GL_COMPILE_AND_EXECUTE		  0x1301L

#define GL_LIST_BASE			  0x0B32L

#define GL_LIST_INDEX			  0x0B33L

#define GL_LIST_MODE			  0x0B30L



	/* Depth buffer */

#define GL_NEVER			  0x0200L

#define GL_LESS				  0x0201L

#define GL_GEQUAL			  0x0206L

#define GL_LEQUAL			  0x0203L

#define GL_GREATER			  0x0204L

#define GL_NOTEQUAL			  0x0205L

#define GL_EQUAL			  0x0202L

#define GL_ALWAYS			  0x0207L

#define GL_DEPTH_TEST			  0x0B71L

#define GL_DEPTH_BITS			  0x0D56L

#define GL_DEPTH_CLEAR_VALUE		  0x0B73L

#define GL_DEPTH_FUNC			  0x0B74L

#define GL_DEPTH_RANGE			  0x0B70L

#define GL_DEPTH_WRITEMASK		  0x0B72L

#define GL_DEPTH_COMPONENT		  0x1902L



	/* Lighting */

#define GL_LIGHTING			  0x0B50L

#define GL_LIGHT0			  0x4000L

#define GL_LIGHT1			  0x4001L

#define GL_LIGHT2			  0x4002L

#define GL_LIGHT3			  0x4003L

#define GL_LIGHT4			  0x4004L

#define GL_LIGHT5			  0x4005L

#define GL_LIGHT6			  0x4006L

#define GL_LIGHT7			  0x4007L

#define GL_SPOT_EXPONENT		  0x1205L

#define GL_SPOT_CUTOFF			  0x1206L

#define GL_CONSTANT_ATTENUATION		  0x1207L

#define GL_LINEAR_ATTENUATION		  0x1208L

#define GL_QUADRATIC_ATTENUATION	  0x1209L

#define GL_AMBIENT			  0x1200L

#define GL_DIFFUSE			  0x1201L

#define GL_SPECULAR			  0x1202L

#define GL_SHININESS			  0x1601L

#define GL_EMISSION			  0x1600L

#define GL_POSITION			  0x1203L

#define GL_SPOT_DIRECTION		  0x1204L

#define GL_AMBIENT_AND_DIFFUSE		  0x1602L

#define GL_COLOR_INDEXES		  0x1603L

#define GL_LIGHT_MODEL_TWO_SIDE		  0x0B52L

#define GL_LIGHT_MODEL_LOCAL_VIEWER	  0x0B51L

#define GL_LIGHT_MODEL_AMBIENT		  0x0B53L

#define GL_FRONT_AND_BACK		  0x0408L

#define GL_SHADE_MODEL			  0x0B54L

#define GL_FLAT				  0x1D00L

#define GL_SMOOTH			  0x1D01L

#define GL_COLOR_MATERIAL		  0x0B57L

#define GL_COLOR_MATERIAL_FACE		  0x0B55L

#define GL_COLOR_MATERIAL_PARAMETER	  0x0B56L

#define GL_NORMALIZE			  0x0BA1L



	/* User clipping planes */

#define GL_CLIP_PLANE0			  0x3000L

#define GL_CLIP_PLANE1			  0x3001L

#define GL_CLIP_PLANE2			  0x3002L

#define GL_CLIP_PLANE3			  0x3003L

#define GL_CLIP_PLANE4			  0x3004L

#define GL_CLIP_PLANE5			  0x3005L



	/* Accumulation buffer */

#define GL_ACCUM_RED_BITS		  0x0D58L

#define GL_ACCUM_GREEN_BITS		  0x0D59L

#define GL_ACCUM_BLUE_BITS		  0x0D5AL

#define GL_ACCUM_ALPHA_BITS		  0x0D5BL

#define GL_ACCUM_CLEAR_VALUE		  0x0B80L

#define GL_ACCUM			  0x0100L

#define GL_ADD				  0x0104L

#define GL_LOAD				  0x0101L

#define GL_MULT				  0x0103L

#define GL_RETURN			  0x0102L



	/* Alpha testing */

#define GL_ALPHA_TEST			  0x0BC0L

#define GL_ALPHA_TEST_REF		  0x0BC2L

#define GL_ALPHA_TEST_FUNC		  0x0BC1L



	/* Blending */

#define GL_BLEND			  0x0BE2L

#define GL_BLEND_SRC			  0x0BE1L

#define GL_BLEND_DST			  0x0BE0L

#define GL_ZERO				  0L

#define GL_ONE				  1L

#define GL_SRC_COLOR			  0x0300L

#define GL_ONE_MINUS_SRC_COLOR		  0x0301L

#define GL_DST_COLOR			  0x0306L

#define GL_ONE_MINUS_DST_COLOR		  0x0307L

#define GL_SRC_ALPHA			  0x0302L

#define GL_ONE_MINUS_SRC_ALPHA		  0x0303L

#define GL_DST_ALPHA			  0x0304L

#define GL_ONE_MINUS_DST_ALPHA		  0x0305L

#define GL_SRC_ALPHA_SATURATE		  0x0308L

#define GL_CONSTANT_COLOR		  0x8001L

#define GL_ONE_MINUS_CONSTANT_COLOR	  0x8002L

#define GL_CONSTANT_ALPHA		  0x8003L

#define GL_ONE_MINUS_CONSTANT_ALPHA	  0x8004L



	/* Render Mode */

#define GL_FEEDBACK			  0x1C01L

#define GL_RENDER			  0x1C00L

#define GL_SELECT			  0x1C02L



	/* Feedback */

#define GL_2D				  0x0600L

#define GL_3D				  0x0601L

#define GL_3D_COLOR			  0x0602L

#define GL_3D_COLOR_TEXTURE		  0x0603L

#define GL_4D_COLOR_TEXTURE		  0x0604L

#define GL_POINT_TOKEN			  0x0701L

#define GL_LINE_TOKEN			  0x0702L

#define GL_LINE_RESET_TOKEN		  0x0707L

#define GL_POLYGON_TOKEN		  0x0703L

#define GL_BITMAP_TOKEN			  0x0704L

#define GL_DRAW_PIXEL_TOKEN		  0x0705L

#define GL_COPY_PIXEL_TOKEN		  0x0706L

#define GL_PASS_THROUGH_TOKEN		  0x0700L

#define GL_FEEDBACK_BUFFER_POINTER	  0x0DF0L

#define GL_FEEDBACK_BUFFER_SIZE		  0x0DF1L

#define GL_FEEDBACK_BUFFER_TYPE		  0x0DF2L



	/* Fog */

#define GL_FOG				  0x0B60L

#define GL_FOG_MODE			  0x0B65L

#define GL_FOG_DENSITY			  0x0B62L

#define GL_FOG_COLOR			  0x0B66L

#define GL_FOG_INDEX			  0x0B61L

#define GL_FOG_START			  0x0B63L

#define GL_FOG_END			  0x0B64L

#define GL_LINEAR			  0x2601L

#define GL_EXP				  0x0800L

#define GL_EXP2				  0x0801L



	/* Logic Ops */

#define GL_LOGIC_OP			  0x0BF1L

#define GL_INDEX_LOGIC_OP		  0x0BF1L

#define GL_COLOR_LOGIC_OP		  0x0BF2L

#define GL_LOGIC_OP_MODE		  0x0BF0L

#define GL_CLEAR			  0x1500L

#define GL_SET				  0x150FL

#define GL_COPY				  0x1503L

#define GL_COPY_INVERTED		  0x150CL

#define GL_NOOP				  0x1505L

#define GL_INVERT			  0x150AL

#define GL_AND				  0x1501L

#define GL_NAND				  0x150EL

#define GL_OR				  0x1507L

#define GL_NOR				  0x1508L

#define GL_XOR				  0x1506L

#define GL_EQUIV			  0x1509L

#define GL_AND_REVERSE			  0x1502L

#define GL_AND_INVERTED			  0x1504L

#define GL_OR_REVERSE			  0x150BL

#define GL_OR_INVERTED			  0x150DL



	/* Stencil */

#define GL_STENCIL_TEST			  0x0B90L

#define GL_STENCIL_WRITEMASK		  0x0B98L

#define GL_STENCIL_BITS			  0x0D57L

#define GL_STENCIL_FUNC			  0x0B92L

#define GL_STENCIL_VALUE_MASK		  0x0B93L

#define GL_STENCIL_REF			  0x0B97L

#define GL_STENCIL_FAIL			  0x0B94L

#define GL_STENCIL_PASS_DEPTH_PASS	  0x0B96L

#define GL_STENCIL_PASS_DEPTH_FAIL	  0x0B95L

#define GL_STENCIL_CLEAR_VALUE		  0x0B91L

#define GL_STENCIL_INDEX		  0x1901L

#define GL_KEEP				  0x1E00L

#define GL_REPLACE			  0x1E01L

#define GL_INCR				  0x1E02L

#define GL_DECR				  0x1E03L



	/* Buffers, Pixel Drawing/Reading */

#define GL_NONE				  0L

#define GL_LEFT				  0x0406L

#define GL_RIGHT			  0x0407L

	/*#define GL_FRONT			  0x0404L */

	/*#define GL_BACK			  0x0405L */

	/*#define GL_FRONT_AND_BACK		  0x0408L */

#define GL_FRONT_LEFT			  0x0400L

#define GL_FRONT_RIGHT			  0x0401L

#define GL_BACK_LEFT			  0x0402L

#define GL_BACK_RIGHT			  0x0403L

#define GL_AUX0				  0x0409L

#define GL_AUX1				  0x040AL

#define GL_AUX2				  0x040BL

#define GL_AUX3				  0x040CL

#define GL_COLOR_INDEX			  0x1900L

#define GL_RED				  0x1903L

#define GL_GREEN			  0x1904L

#define GL_BLUE				  0x1905L

#define GL_ALPHA			  0x1906L

#define GL_LUMINANCE			  0x1909L

#define GL_LUMINANCE_ALPHA		  0x190AL

#define GL_ALPHA_BITS			  0x0D55L

#define GL_RED_BITS			  0x0D52L

#define GL_GREEN_BITS			  0x0D53L

#define GL_BLUE_BITS			  0x0D54L

#define GL_INDEX_BITS			  0x0D51L

#define GL_SUBPIXEL_BITS		  0x0D50L

#define GL_AUX_BUFFERS			  0x0C00L

#define GL_READ_BUFFER			  0x0C02L

#define GL_DRAW_BUFFER			  0x0C01L

#define GL_DOUBLEBUFFER			  0x0C32L

#define GL_STEREO			  0x0C33L

#define GL_BITMAP			  0x1A00L

#define GL_COLOR			  0x1800L

#define GL_DEPTH			  0x1801L

#define GL_STENCIL			  0x1802L

#define GL_DITHER			  0x0BD0L

#define GL_RGB				  0x1907L

#define GL_RGBA				  0x1908L



	/* Implementation limits */

#define GL_MAX_LIST_NESTING		  0x0B31L

#define GL_MAX_ATTRIB_STACK_DEPTH	  0x0D35L

#define GL_MAX_MODELVIEW_STACK_DEPTH	  0x0D36L

#define GL_MAX_NAME_STACK_DEPTH		  0x0D37L

#define GL_MAX_PROJECTION_STACK_DEPTH	  0x0D38L

#define GL_MAX_TEXTURE_STACK_DEPTH	  0x0D39L

#define GL_MAX_EVAL_ORDER		  0x0D30L

#define GL_MAX_LIGHTS			  0x0D31L

#define GL_MAX_CLIP_PLANES		  0x0D32L

#define GL_MAX_TEXTURE_SIZE		  0x0D33L

#define GL_MAX_PIXEL_MAP_TABLE		  0x0D34L

#define GL_MAX_VIEWPORT_DIMS		  0x0D3AL

#define GL_MAX_CLIENT_ATTRIB_STACK_DEPTH  0x0D3BL



	/* Gets */

#define GL_ATTRIB_STACK_DEPTH		  0x0BB0L

#define GL_CLIENT_ATTRIB_STACK_DEPTH	  0x0BB1L

#define GL_COLOR_CLEAR_VALUE		  0x0C22L

#define GL_COLOR_WRITEMASK		  0x0C23L

#define GL_CURRENT_INDEX		  0x0B01L

#define GL_CURRENT_COLOR		  0x0B00L

#define GL_CURRENT_NORMAL		  0x0B02L

#define GL_CURRENT_RASTER_COLOR		  0x0B04L

#define GL_CURRENT_RASTER_DISTANCE	  0x0B09L

#define GL_CURRENT_RASTER_INDEX		  0x0B05L

#define GL_CURRENT_RASTER_POSITION	  0x0B07L

#define GL_CURRENT_RASTER_TEXTURE_COORDS   0x0B06L

#define GL_CURRENT_RASTER_POSITION_VALID   0x0B08L

#define GL_CURRENT_TEXTURE_COORDS	  0x0B03L

#define GL_INDEX_CLEAR_VALUE		  0x0C20L

#define GL_INDEX_MODE			  0x0C30L

#define GL_INDEX_WRITEMASK		  0x0C21L

#define GL_MODELVIEW_MATRIX		  0x0BA6L

#define GL_MODELVIEW_STACK_DEPTH	  0x0BA3L

#define GL_NAME_STACK_DEPTH		  0x0D70L

#define GL_PROJECTION_MATRIX		  0x0BA7L

#define GL_PROJECTION_STACK_DEPTH	  0x0BA4L

#define GL_RENDER_MODE			  0x0C40L

#define GL_RGBA_MODE			  0x0C31L

#define GL_TEXTURE_MATRIX		  0x0BA8L

#define GL_TEXTURE_STACK_DEPTH		  0x0BA5L

#define GL_VIEWPORT			  0x0BA2L





	/* Evaluators */

#define GL_AUTO_NORMAL			  0x0D80L

#define GL_MAP1_COLOR_4			  0x0D90L

#define GL_MAP1_GRID_DOMAIN		  0x0DD0L

#define GL_MAP1_GRID_SEGMENTS		  0x0DD1L

#define GL_MAP1_INDEX			  0x0D91L

#define GL_MAP1_NORMAL			  0x0D92L

#define GL_MAP1_TEXTURE_COORD_1		  0x0D93L

#define GL_MAP1_TEXTURE_COORD_2		  0x0D94L

#define GL_MAP1_TEXTURE_COORD_3		  0x0D95L

#define GL_MAP1_TEXTURE_COORD_4		  0x0D96L

#define GL_MAP1_VERTEX_3		  0x0D97L

#define GL_MAP1_VERTEX_4		  0x0D98L

#define GL_MAP2_COLOR_4			  0x0DB0L

#define GL_MAP2_GRID_DOMAIN		  0x0DD2L

#define GL_MAP2_GRID_SEGMENTS		  0x0DD3L

#define GL_MAP2_INDEX			  0x0DB1L

#define GL_MAP2_NORMAL			  0x0DB2L

#define GL_MAP2_TEXTURE_COORD_1		  0x0DB3L

#define GL_MAP2_TEXTURE_COORD_2		  0x0DB4L

#define GL_MAP2_TEXTURE_COORD_3		  0x0DB5L

#define GL_MAP2_TEXTURE_COORD_4		  0x0DB6L

#define GL_MAP2_VERTEX_3		  0x0DB7L

#define GL_MAP2_VERTEX_4		  0x0DB8L

#define GL_COEFF			  0x0A00L

#define GL_DOMAIN			  0x0A02L

#define GL_ORDER			  0x0A01L



	/* Hints */

#define GL_FOG_HINT			  0x0C54L

#define GL_LINE_SMOOTH_HINT		  0x0C52L

#define GL_PERSPECTIVE_CORRECTION_HINT	  0x0C50L

#define GL_POINT_SMOOTH_HINT		  0x0C51L

#define GL_POLYGON_SMOOTH_HINT		  0x0C53L

#define GL_DONT_CARE			  0x1100L

#define GL_FASTEST			  0x1101L

#define GL_NICEST			  0x1102L



	/* Scissor box */

#define GL_SCISSOR_TEST			  0x0C11L

#define GL_SCISSOR_BOX			  0x0C10L



	/* Pixel Mode / Transfer */

#define GL_MAP_COLOR			  0x0D10L

#define GL_MAP_STENCIL			  0x0D11L

#define GL_INDEX_SHIFT			  0x0D12L

#define GL_INDEX_OFFSET			  0x0D13L

#define GL_RED_SCALE			  0x0D14L

#define GL_RED_BIAS			  0x0D15L

#define GL_GREEN_SCALE			  0x0D18L

#define GL_GREEN_BIAS			  0x0D19L

#define GL_BLUE_SCALE			  0x0D1AL

#define GL_BLUE_BIAS			  0x0D1BL

#define GL_ALPHA_SCALE			  0x0D1CL

#define GL_ALPHA_BIAS			  0x0D1DL

#define GL_DEPTH_SCALE			  0x0D1EL

#define GL_DEPTH_BIAS			  0x0D1FL

#define GL_PIXEL_MAP_S_TO_S_SIZE	  0x0CB1L

#define GL_PIXEL_MAP_I_TO_I_SIZE	  0x0CB0L

#define GL_PIXEL_MAP_I_TO_R_SIZE	  0x0CB2L

#define GL_PIXEL_MAP_I_TO_G_SIZE	  0x0CB3L

#define GL_PIXEL_MAP_I_TO_B_SIZE	  0x0CB4L

#define GL_PIXEL_MAP_I_TO_A_SIZE	  0x0CB5L

#define GL_PIXEL_MAP_R_TO_R_SIZE	  0x0CB6L

#define GL_PIXEL_MAP_G_TO_G_SIZE	  0x0CB7L

#define GL_PIXEL_MAP_B_TO_B_SIZE	  0x0CB8L

#define GL_PIXEL_MAP_A_TO_A_SIZE	  0x0CB9L

#define GL_PIXEL_MAP_S_TO_S		  0x0C71L

#define GL_PIXEL_MAP_I_TO_I		  0x0C70L

#define GL_PIXEL_MAP_I_TO_R		  0x0C72L

#define GL_PIXEL_MAP_I_TO_G		  0x0C73L

#define GL_PIXEL_MAP_I_TO_B		  0x0C74L

#define GL_PIXEL_MAP_I_TO_A		  0x0C75L

#define GL_PIXEL_MAP_R_TO_R		  0x0C76L

#define GL_PIXEL_MAP_G_TO_G		  0x0C77L

#define GL_PIXEL_MAP_B_TO_B		  0x0C78L

#define GL_PIXEL_MAP_A_TO_A		  0x0C79L

#define GL_PACK_ALIGNMENT		  0x0D05L

#define GL_PACK_LSB_FIRST		  0x0D01L

#define GL_PACK_ROW_LENGTH		  0x0D02L

#define GL_PACK_SKIP_PIXELS		  0x0D04L

#define GL_PACK_SKIP_ROWS		  0x0D03L

#define GL_PACK_SWAP_BYTES		  0x0D00L

#define GL_UNPACK_ALIGNMENT		  0x0CF5L

#define GL_UNPACK_LSB_FIRST		  0x0CF1L

#define GL_UNPACK_ROW_LENGTH		  0x0CF2L

#define GL_UNPACK_SKIP_PIXELS		  0x0CF4L

#define GL_UNPACK_SKIP_ROWS		  0x0CF3L

#define GL_UNPACK_SWAP_BYTES		  0x0CF0L

#define GL_ZOOM_X			  0x0D16L

#define GL_ZOOM_Y			  0x0D17L



	/* Texture mapping */

#define GL_TEXTURE_ENV			  0x2300L

#define GL_TEXTURE_ENV_MODE		  0x2200L

#define GL_TEXTURE_1D			  0x0DE0L

#define GL_TEXTURE_2D			  0x0DE1L

#define GL_TEXTURE_WRAP_S		  0x2802L

#define GL_TEXTURE_WRAP_T		  0x2803L

#define GL_TEXTURE_MAG_FILTER		  0x2800L

#define GL_TEXTURE_MIN_FILTER		  0x2801L

#define GL_TEXTURE_ENV_COLOR		  0x2201L

#define GL_TEXTURE_GEN_S		  0x0C60L

#define GL_TEXTURE_GEN_T		  0x0C61L

#define GL_TEXTURE_GEN_MODE		  0x2500L

#define GL_TEXTURE_BORDER_COLOR		  0x1004L

#define GL_TEXTURE_WIDTH		  0x1000L

#define GL_TEXTURE_HEIGHT		  0x1001L

#define GL_TEXTURE_BORDER		  0x1005L

#define GL_TEXTURE_COMPONENTS		  0x1003L

#define GL_TEXTURE_RED_SIZE		  0x805CL

#define GL_TEXTURE_GREEN_SIZE		  0x805DL

#define GL_TEXTURE_BLUE_SIZE		  0x805EL

#define GL_TEXTURE_ALPHA_SIZE		  0x805FL

#define GL_TEXTURE_LUMINANCE_SIZE	  0x8060L

#define GL_TEXTURE_INTENSITY_SIZE	  0x8061L

#define GL_NEAREST_MIPMAP_NEAREST	  0x2700L

#define GL_NEAREST_MIPMAP_LINEAR	  0x2702L

#define GL_LINEAR_MIPMAP_NEAREST	  0x2701L

#define GL_LINEAR_MIPMAP_LINEAR		  0x2703L

#define GL_OBJECT_LINEAR		  0x2401L

#define GL_OBJECT_PLANE			  0x2501L

#define GL_EYE_LINEAR			  0x2400L

#define GL_EYE_PLANE			  0x2502L

#define GL_SPHERE_MAP			  0x2402L

#define GL_DECAL			  0x2101L

#define GL_MODULATE			  0x2100L

#define GL_NEAREST			  0x2600L

#define GL_REPEAT			  0x2901L

#define GL_CLAMP			  0x2900L

#define GL_S				  0x2000L

#define GL_T				  0x2001L

#define GL_R				  0x2002L

#define GL_Q				  0x2003L

#define GL_TEXTURE_GEN_R		  0x0C62L

#define GL_TEXTURE_GEN_Q		  0x0C63L



#define GL_PROXY_TEXTURE_1D		  0x8063L

#define GL_PROXY_TEXTURE_2D		  0x8064L

#define GL_TEXTURE_PRIORITY		  0x8066L

#define GL_TEXTURE_RESIDENT		  0x8067L

#define GL_TEXTURE_BINDING_1D		  0x8068L

#define GL_TEXTURE_BINDING_2D		  0x8069L



	/* Internal texture formats */

#define GL_ALPHA4			  0x803BL

#define GL_ALPHA8			  0x803CL

#define GL_ALPHA12			  0x803DL

#define GL_ALPHA16			  0x803EL

#define GL_LUMINANCE4			  0x803FL

#define GL_LUMINANCE8			  0x8040L

#define GL_LUMINANCE12			  0x8041L

#define GL_LUMINANCE16			  0x8042L

#define GL_LUMINANCE4_ALPHA4		  0x8043L

#define GL_LUMINANCE6_ALPHA2		  0x8044L

#define GL_LUMINANCE8_ALPHA8		  0x8045L

#define GL_LUMINANCE12_ALPHA4		  0x8046L

#define GL_LUMINANCE12_ALPHA12		  0x8047L

#define GL_LUMINANCE16_ALPHA16		  0x8048L

#define GL_INTENSITY			  0x8049L

#define GL_INTENSITY4			  0x804AL

#define GL_INTENSITY8			  0x804BL

#define GL_INTENSITY12			  0x804CL

#define GL_INTENSITY16			  0x804DL

#define GL_R3_G3_B2			  0x2A10L

#define GL_RGB4				  0x804FL

#define GL_RGB5				  0x8050L

#define GL_RGB8				  0x8051L

#define GL_RGB10			  0x8052L

#define GL_RGB12			  0x8053L

#define GL_RGB16			  0x8054L

#define GL_RGBA2			  0x8055L

#define GL_RGBA4			  0x8056L

#define GL_RGB5_A1			  0x8057L

#define GL_RGBA8			  0x8058L

#define GL_RGB10_A2			  0x8059L

#define GL_RGBA12			  0x805AL

#define GL_RGBA16			  0x805BL



	/* Utility */

#define GL_VENDOR			  0x1F00L

#define GL_RENDERER			  0x1F01L

#define GL_VERSION			  0x1F02L

#define GL_EXTENSIONS			  0x1F03L



	/* Errors */

#define GL_INVALID_VALUE		  0x0501L

#define GL_INVALID_ENUM			  0x0500L

#define GL_INVALID_OPERATION		  0x0502L

#define GL_STACK_OVERFLOW		  0x0503L

#define GL_STACK_UNDERFLOW		  0x0504L

#define GL_OUT_OF_MEMORY		  0x0505L



	/*

	 * 1.0 Extensions

	 */

/* GL_EXT_blend_minmax and GL_EXT_blend_color */

#define GL_CONSTANT_COLOR_EXT		  0x8001L

#define GL_ONE_MINUS_CONSTANT_COLOR_EXT	  0x8002L

#define GL_CONSTANT_ALPHA_EXT		  0x8003L

#define GL_ONE_MINUS_CONSTANT_ALPHA_EXT	  0x8004L

#define GL_BLEND_EQUATION_EXT		  0x8009L

#define GL_MIN_EXT			  0x8007L

#define GL_MAX_EXT			  0x8008L

#define GL_FUNC_ADD_EXT			  0x8006L

#define GL_FUNC_SUBTRACT_EXT		  0x800AL

#define GL_FUNC_REVERSE_SUBTRACT_EXT	  0x800BL

#define GL_BLEND_COLOR_EXT		  0x8005L



	/* GL_EXT_polygon_offset */

#define GL_POLYGON_OFFSET_EXT             0x8037L

#define GL_POLYGON_OFFSET_FACTOR_EXT      0x8038L

#define GL_POLYGON_OFFSET_BIAS_EXT        0x8039L



	/* GL_EXT_vertex_array */

#define GL_VERTEX_ARRAY_EXT			  0x8074L

#define GL_NORMAL_ARRAY_EXT			  0x8075L

#define GL_COLOR_ARRAY_EXT			  0x8076L

#define GL_INDEX_ARRAY_EXT			  0x8077L

#define GL_TEXTURE_COORD_ARRAY_EXT		  0x8078L

#define GL_EDGE_FLAG_ARRAY_EXT			  0x8079L

#define GL_VERTEX_ARRAY_SIZE_EXT		  0x807AL

#define GL_VERTEX_ARRAY_TYPE_EXT		  0x807BL

#define GL_VERTEX_ARRAY_STRIDE_EXT		  0x807CL

#define GL_VERTEX_ARRAY_COUNT_EXT		  0x807DL

#define GL_NORMAL_ARRAY_TYPE_EXT		  0x807EL

#define GL_NORMAL_ARRAY_STRIDE_EXT		  0x807FL

#define GL_NORMAL_ARRAY_COUNT_EXT		  0x8080L

#define GL_COLOR_ARRAY_SIZE_EXT			  0x8081L

#define GL_COLOR_ARRAY_TYPE_EXT			  0x8082L

#define GL_COLOR_ARRAY_STRIDE_EXT		  0x8083L

#define GL_COLOR_ARRAY_COUNT_EXT		  0x8084L

#define GL_INDEX_ARRAY_TYPE_EXT			  0x8085L

#define GL_INDEX_ARRAY_STRIDE_EXT		  0x8086L

#define GL_INDEX_ARRAY_COUNT_EXT		  0x8087L

#define GL_TEXTURE_COORD_ARRAY_SIZE_EXT		  0x8088L

#define GL_TEXTURE_COORD_ARRAY_TYPE_EXT		  0x8089L

#define GL_TEXTURE_COORD_ARRAY_STRIDE_EXT	  0x808AL

#define GL_TEXTURE_COORD_ARRAY_COUNT_EXT	  0x808BL

#define GL_EDGE_FLAG_ARRAY_STRIDE_EXT		  0x808CL

#define GL_EDGE_FLAG_ARRAY_COUNT_EXT		  0x808DL

#define GL_VERTEX_ARRAY_POINTER_EXT		  0x808EL

#define GL_NORMAL_ARRAY_POINTER_EXT		  0x808FL

#define GL_COLOR_ARRAY_POINTER_EXT		  0x8090L

#define GL_INDEX_ARRAY_POINTER_EXT		  0x8091L

#define GL_TEXTURE_COORD_ARRAY_POINTER_EXT	  0x8092L

#define GL_EDGE_FLAG_ARRAY_POINTER_EXT		  0x8093L



	/* GL_EXT_texture_object */

#define GL_TEXTURE_PRIORITY_EXT		  0x8066L

#define GL_TEXTURE_RESIDENT_EXT		  0x8067L

#define GL_TEXTURE_1D_BINDING_EXT	  0x8068L

#define GL_TEXTURE_2D_BINDING_EXT	  0x8069L



	/* GL_EXT_texture3D */

#define GL_PACK_SKIP_IMAGES_EXT		  0x806BL

#define GL_PACK_IMAGE_HEIGHT_EXT	  0x806CL

#define GL_UNPACK_SKIP_IMAGES_EXT	  0x806DL

#define GL_UNPACK_IMAGE_HEIGHT_EXT	  0x806EL

#define GL_TEXTURE_3D_EXT		  0x806FL

#define GL_PROXY_TEXTURE_3D_EXT		  0x8070L

#define GL_TEXTURE_DEPTH_EXT		  0x8071L

#define GL_TEXTURE_WRAP_R_EXT		  0x8072L

#define GL_MAX_3D_TEXTURE_SIZE_EXT	  0x8073L

#define GL_TEXTURE_3D_BINDING_EXT	  0x806AL



/* GL_EXT_paletted_texture */

#define GL_TABLE_TOO_LARGE_EXT			  0x8031L

#define GL_COLOR_TABLE_FORMAT_EXT		  0x80D8L

#define GL_COLOR_TABLE_WIDTH_EXT		  0x80D9L

#define GL_COLOR_TABLE_RED_SIZE_EXT		  0x80DAL

#define GL_COLOR_TABLE_GREEN_SIZE_EXT		  0x80DBL

#define GL_COLOR_TABLE_BLUE_SIZE_EXT		  0x80DCL

#define GL_COLOR_TABLE_ALPHA_SIZE_EXT		  0x80DDL

#define GL_COLOR_TABLE_LUMINANCE_SIZE_EXT	  0x80DEL

#define GL_COLOR_TABLE_INTENSITY_SIZE_EXT	  0x80DFL

#define GL_TEXTURE_INDEX_SIZE_EXT		  0x80E1L /*XXX right value??*/

#define GL_COLOR_INDEX1_EXT			  0x80E2L

#define GL_COLOR_INDEX2_EXT			  0x80E3L

#define GL_COLOR_INDEX4_EXT			  0x80E4L

#define GL_COLOR_INDEX8_EXT			  0x80E5L

#define GL_COLOR_INDEX12_EXT			  0x80E6L

#define GL_COLOR_INDEX16_EXT			  0x80E7L



	/* GL_EXT_shared_texture_palette */

#define GL_SHARED_TEXTURE_PALETTE_EXT		  0x81FBL



#if 0

	/* GL_SGIS_texture_lod */

#define GL_TEXTURE_MIN_LOD_SGIS			  0x813AL

#define GL_TEXTURE_MAX_LOD_SGIS			  0x813BL

#define GL_TEXTURE_BASE_LEVEL_SGIS		 0x813CL

#define GL_TEXTURE_MAX_LEVEL_SGIS		  0x813DL

#endif



	/* GL_EXT_point_parameters */

#define GL_POINT_SIZE_MIN_EXT			  0x8126L

#define GL_POINT_SIZE_MAX_EXT			  0x8127L

#define GL_POINT_FADE_THRESHOLD_SIZE_EXT	  0x8128L

#define GL_DISTANCE_ATTENUATION_EXT		0x8129



typedef long GLenum; /* Pour tre sr que a passe avec les LDG */



enum {

	GL_CURRENT_BIT		= 0x00000001L,

	GL_POINT_BIT		= 0x00000002L,

	GL_LINE_BIT		= 0x00000004L,

	GL_POLYGON_BIT		= 0x00000008L,

	GL_POLYGON_STIPPLE_BIT	= 0x00000010L,

	GL_PIXEL_MODE_BIT	= 0x00000020L,

	GL_LIGHTING_BIT		= 0x00000040L,

	GL_FOG_BIT		= 0x00000080L,

	GL_DEPTH_BUFFER_BIT	= 0x00000100L,

	GL_ACCUM_BUFFER_BIT	= 0x00000200L,

	GL_STENCIL_BUFFER_BIT	= 0x00000400L,

	GL_VIEWPORT_BIT		= 0x00000800L,

	GL_TRANSFORM_BIT	= 0x00001000L,

	GL_ENABLE_BIT		= 0x00002000L,

	GL_COLOR_BUFFER_BIT	= 0x00004000L,

	GL_HINT_BIT		= 0x00008000L,

	GL_EVAL_BIT		= 0x00010000L,

	GL_LIST_BIT		= 0x00020000L,

	GL_TEXTURE_BIT		= 0x00040000L,

	GL_SCISSOR_BIT		= 0x00080000L,

	GL_ALL_ATTRIB_BITS	= 0x000fffffL

};



enum {

	GL_CLIENT_PIXEL_STORE_BIT	= 0x00000001L,

	GL_CLIENT_VERTEX_ARRAY_BIT	= 0x00000002L,

	GL_CLIENT_ALL_ATTRIB_BITS	= 0x0000FFFFL

};



typedef unsigned long GLbitfield;



/*  C type		GL type		storage                            */

/**/

typedef void		GLvoid;

typedef unsigned long	GLboolean;

typedef signed long	GLbyte;		/* 1byte signed */

typedef long		GLshort;	/* 2byte signed */

typedef long		GLint;		/* 4byte signed */

typedef unsigned long	GLubyte;	/* 1byte unsigned */

typedef unsigned long	GLushort;	/* 2byte unsigned */

typedef unsigned long	GLuint;		/* 4byte unsigned */

typedef long		GLsizei;	/* 4byte signed */

typedef float		GLfloat;	/* single precision float */

typedef float		GLclampf;	/* single precision float in [0,1] */

typedef float		GLdouble;	/* double precision float */

typedef float		GLclampd;	/* double precision float in [0,1] */



/* Ce qui suit devrait normalement tre dans glu.h, mais bon... */



#if defined(_PURE_C_) || defined(_TURBO_C_)

# define CALLBACK cdecl

# define APIENTRY cdecl

#else

# define CALLBACK __CDECL

# define APIENTRY __CDECL

#endif



typedef struct

{

	GLenum	DrawStyle;		/* GLU_FILL, LINE, SILHOUETTE, or POINT */

	GLenum Orientation;		/* GLU_INSIDE or GLU_OUTSIDE */

	GLboolean TextureFlag;		/* Generate texture coords? */

	GLenum Normals;		/* GLU_NONE, GLU_FLAT, or GLU_SMOOTH */

	void (CALLBACK *ErrorFunc)(GLenum err);	/* Error handler callback function */

} GLUquadricObj;



#include "nurbsldg.h"



/* Maintenant, les prototypes des fonctions (repris de proto.h)

   Elles sont dfinies en variables externes, sauf si EXTERN est dj dfini...

*/





#ifndef EXTERN

# define EXTERN extern

#endif



#endif /* GL_H_ */